/*
 *   Copyright 2011 Institute of Communication and Computer Systems (ICCS) 
 *
 *   Licensed under the Apache License, Version 2.0 (the "License");
 *   you may not use this file except in compliance with the License.
 *   You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 *   Unless required by applicable law or agreed to in writing, software
 *   distributed under the License is distributed on an "AS IS" BASIS,
 *   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *   See the License for the specific language governing permissions and
 *   limitations under the License.
 *
 */

#ifndef DMMLIB_H
#define DMMLIB_H
#include <dmmlib/heap.h>
#include "dmm_config.h"

void * custom_ahmalloc(allocator_t* allocator, heap_t* heap, size_t size);
void custom_ahfree(allocator_t *allocator, heap_t* heap, void *ptr);

#ifndef WITH_MEMORY_SPACE_AWARENESS
void * custom_malloc(size_t size);
void custom_free(void *ptr);

allocator_t systemallocator;
#endif /* WITH_MEMORY_SPACE_AWARENESS */

#ifdef REPLACE_MALLOC

#define malloc(size) custom_ahmalloc(NULL, NULL, size)
#define free(ptr) custom_ahfree(NULL, NULL, ptr)

#endif /* REPLACE_MALLOC */

#endif /* DMMLIB_H */
