/*
 *   Copyright 2011 Institute of Communication and Computer Systems (ICCS) 
 *
 *   Licensed under the Apache License, Version 2.0 (the "License");
 *   you may not use this file except in compliance with the License.
 *   You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 *   Unless required by applicable law or agreed to in writing, software
 *   distributed under the License is distributed on an "AS IS" BASIS,
 *   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *   See the License for the specific language governing permissions and
 *   limitations under the License.
 *
 */

#ifndef COALESCE_H
#define COALESCE_H

#include <dmmlib/heap.h>

/**
 * Merges a memory block with its previous one if the latter one is free.
 *
 * @param ptr The memory block to be checked.
 * @param heap The heap of the memory block.
 */
void * coalesce(allocator_t *allocator, heap_t *heap, void *ptr, size_t size);

#endif /* COALESCE_H */

