/*
 *   Copyright 2011 Institute of Communication and Computer Systems (ICCS) 
 *
 *   Licensed under the Apache License, Version 2.0 (the "License");
 *   you may not use this file except in compliance with the License.
 *   You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 *   Unless required by applicable law or agreed to in writing, software
 *   distributed under the License is distributed on an "AS IS" BASIS,
 *   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *   See the License for the specific language governing permissions and
 *   limitations under the License.
 *
 */

#include "other.h"
#include <pthread.h>

size_t req_padding(size_t size) {
    size_t align;

    if(size <= 32)
        return 32;
    if(size <= 64)
        return 64;
    if(size <= 128)
        return 128;
    if(size <= 256)
        return 256;

    align = size % 4;
    if(align != 0) {
        size += 4 - align;
    }

    return size;
}

#ifdef WITH_FIXED_LISTS

int map_size_to_list(heap_t *heap, size_t sz) {
    int i;
    maptable_node_t *node;
    i = 0;
    node = heap->maptable_head;
    while(node) {
        if(node->size == sz) {
            return i;
        }
        i++;
        node = node->next;
    }
    return -1;
}

#endif /* WITH_FIXED_LISTS */

#ifndef WITH_MEMORY_SPACE_AWARENESS

/* Random assignment */
int map_thread_heap(void) {
    return (int) (((unsigned long) pthread_self() >> 10) % NUM_HEAPS);
}

#endif /* WITH_MEMORY_SPACE_AWARENESS */

