/*
 *   Copyright 2011 Institute of Communication and Computer Systems (ICCS) 
 *
 *   Licensed under the Apache License, Version 2.0 (the "License");
 *   you may not use this file except in compliance with the License.
 *   You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 *   Unless required by applicable law or agreed to in writing, software
 *   distributed under the License is distributed on an "AS IS" BASIS,
 *   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *   See the License for the specific language governing permissions and
 *   limitations under the License.
 *
 */

#include "posix_lock.h"
#include <pthread.h>

pthread_mutex_t sbrk_mutex = PTHREAD_MUTEX_INITIALIZER;

void sbrk_lock(void) {
    pthread_mutex_lock(&sbrk_mutex);
}

void sbrk_unlock(void) {
    pthread_mutex_unlock(&sbrk_mutex);
}

void posix_lock(heap_t *heap) {
    pthread_mutex_lock(&heap->mutex);
}

void posix_unlock(heap_t *heap) {
    pthread_mutex_unlock(&heap->mutex);
}

