/*
 *   Copyright 2011 Institute of Communication and Computer Systems (ICCS) 
 *
 *   Licensed under the Apache License, Version 2.0 (the "License");
 *   you may not use this file except in compliance with the License.
 *   You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 *   Unless required by applicable law or agreed to in writing, software
 *   distributed under the License is distributed on an "AS IS" BASIS,
 *   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *   See the License for the specific language governing permissions and
 *   limitations under the License.
 *
 */

#include "print_stats.h"
#include "dmm_config.h"

#include <stdio.h>

void print_stats(allocator_t *allocator) {
    int i;

    for(i = 0; i < NUM_HEAPS; i++) {
        printf("Heap %d statistics:\n", i);
        printf("Total malloc() calls: %d\n",
                (int) allocator->heaps[i].dmm_stats.num_malloc);
        printf("Total free() calls: %d\n",
                (int) allocator->heaps[i].dmm_stats.num_free);
        printf("Memory currently allocated: %d\n",
                (int) allocator->heaps[i].dmm_stats.mem_allocated);
        printf("Memory currently requested: %d\n",
                (int) allocator->heaps[i].dmm_stats.mem_requested);
    }
}
